script_name('mafia-tools')
script_author("Serhiy_Rubin")
script_version("29.01.2023")

inspect = require("inspect")

sampev = require 'samp.events'
inicfg = require "inicfg"
dlstatus = require("moonloader").download_status

function main()
	if not isSampLoaded() or not isSampfuncsLoaded() then return end
	while not isSampAvailable() do wait(0) end
    upd_testers.init()
    lua_thread.create(script_update.main)
    repeat wait(0) until sampGetCurrentServerName() ~= "SA-MP"
    repeat wait(0) until sampGetCurrentServerName():find("Samp%-Rp.Ru") or sampGetCurrentServerName():find("SRP")
    local server = getSampRpServerName()
    if server == "" then
        thisScript():unload()
    end
    config.init()
    lua_thread.create(timer_2min.loop)
    lua_thread.create(ammo_timer.loop)
    lua_thread.create(request.loop)
    while true do
        wait(0)

    end
end

-->> MSK TIME
msk_time = {}
msk_time.update = 0
msk_time.time = 0
msk_time.get = function()
    if msk_time.update == 0 then
        return os.time()
    end
    return msk_time.time + (os.time() - msk_time.update)
end

-->> REQUEST
request = {}
request.send = {}
request.base = {}
request.loop = function()
    request.wait = 0
    while true do
        wait(0)
        if os.time() - request.wait >= 5 then
            request.wait = os.time()
            local request_table = {
                sender = getLocalPlayerNickname(),
                server = getServerAddress(),
                room = config.data.room,
                send = request.send,
                rand = os.clock()
            }
            request.send = {}
            local url = string.format("http://mafia.deadpoo.net/%s", encodeJson(request_table))
            local result, text = pcall(openURL, url, os.tmpname(), true)
            if result then
                local result = pcall(request.handler, text)
                if not result then
                    addChatMessage("Сервер 'mafia-tools' не отвечает!")
                    break
                end
            end
        end
    end
end
request.handler = function(text)
    local info = decodeJson(text)
    if info["time"] ~= nil then
        msk_time.update = os.time()
        msk_time.time = info["time"]
    end
    if info["result"] == "ok" then
        for sender, sender_data in pairs(info["data"]) do
            for key, v in pairs(sender_data) do
                if ammo_timer.data[key] ~= nil then
                    if ammo_timer.data[key]["time"] < v["time"] then
                        ammo_timer.data[key]["time"] = v["time"]
                        ammo_timer.data[key]["text"] = v["text"]
                    end
                end
            end
        end
    end
    return true
end

-->> AMMO TIMER
ammo_timer = {}
ammo_timer.last_ammo = ""
ammo_timer.onServerMessage = function(color, message)
    if message:find("^ Следующее ограбление будет доступно в (%d+:%d+:%d+)") then
        if ammo_timer.last_ammo ~= "" then
            request.send[#request.send + 1] = {
                key = ammo_timer.last_ammo,
                text = message:match("^ Следующее ограбление будет доступно в (%d+:%d+:%d+)")
            }
            request.wait = 0
        end
    end
    if message:find("Задание будет доступно через: ") then
        local p1, p2, p3 = string.match(message, "Задание будет доступно через: (%d+):(%d+):(%d+)")
        if(p3 == nil)then
            p1, p2 = string.match(message, "Задание будет доступно через: (%d+):(%d+)")
        end
        if(p1 ~= nil and p2 ~= nil)then
            local mhTimer = 0
            if(p3 ~= nil)then
                mhTimer = tonumber(p1) * 3600
                mhTimer = mhTimer + (tonumber(p2) * 60)
                mhTimer = mhTimer + tonumber(p3)
            else
                mhTimer = mhTimer + (tonumber(p1) * 60)
                mhTimer = mhTimer + tonumber(p2)
            end
            request.send[#request.send + 1] = {
                key = "mhcars",
                second = mhTimer
            }
            request.wait = 0
        end
    end --> by Richard_Holmes
end
ammo_timer.data = {
    ls = { time = 0, text = "00:00:00" },
    sf = { time = 0, text = "00:00:00" },
    lv = { time = 0, text = "00:00:00" },
    mhcars = { time = 0, text = "00:00:00" },
}
ammo_timer.loop = function()
    font = renderCreateFont(config.data.font.name,config.data.font.size,config.data.font.flag)

    local getText = function(key)
        if ammo_timer.data[key]["time"] == 0 then
            return string.format("{%s}%s:{%s} %s", config.data.font.color1, key:upper(), config.data.font.color2, ammo_timer.data[key]["text"])
        else
            local min = math.floor((msk_time.get() - ammo_timer.data[key]["time"]) / 60)
            return string.format("{%s}%s:{%s} %s (%d min)", config.data.font.color1, key:upper(), config.data.font.color2, ammo_timer.data[key]["text"], min)
        end
    end
    while true do
        wait(0)
        local text = string.format("%s\n%s\n%s\n%s", getText("ls"), getText("sf"), getText("lv"), getText("mhcars"))
        renderFontDrawText(font,text,config.data.timer_pos.x,config.data.timer_pos.y,-1)


    end
end
ammo_timer.setpos = function()
    repeat
        wait(0)
        sampSetCursorMode(3)
        local x, y = getCursorPos()
        config.data.timer_pos.x = x
        config.data.timer_pos.y = y
    until isKeyDown(1)
    sampSetCursorMode(0)
    config.save(config.data)
end


-->> 2 MIN TIMER
timer_2min = {}
timer_2min.onServerMessage = function(color, message)
    if message:find("Война за бизнес .+ продлена на 2 минуты") then
        local now = os.time() - config.data.time_2min
        if now < 300 and (os.time() - config.data.time_2min) > 120 then
            addChatMessage("2 мин длилось на "..((os.time() - config.data.time_2min) - 120).." секунд больше")
        end
        config.data.time_2min = os.time()
        config.save(config.data)
    end
end
timer_2min.loop = function()
    while true do
        wait(0)
        for a = 0, 2304 do
            if sampTextdrawIsExists(a) then
                local x, y = sampTextdrawGetPos(a)
                if math.ceil(x) == 87 and math.ceil(y) == 256 then
                    local time = 120 - (os.time() - config.data.time_2min)
                    local text = string.format("%02d:%02d", math.floor(time / 60), time % 60)
                    if time < 120 and time >= 0 and sampTextdrawGetString(a) ~= text then
                        sampTextdrawSetString(a,text)
                    end
                end
            end
        end
    end
end

-->> CONFIG
config = {}
config.data = {}
local x1, y1 = convertGameScreenCoordsToWindowScreenCoords(14, 310)
config.default = {
    font = {
        name = "Segoe UI",
        size = 10,
        flag = 13,
        color1 = "2f72f7",
        color2 = "ffffff"
    },
    timer_pos = {
        x = x1,
        y = y1
    },
    time_2min = 0,
    room = "all"
}
config.directory = string.format("%s\\moonloader\\config\\%s\\", getGameDirectory(), thisScript().name)
config.init = function()
    if not doesDirectoryExist("moonloader\\config") then
        createDirectory("moonloader\\config")
    end
    if not doesDirectoryExist(config.directory) then
        createDirectory(config.directory)
    end
    config.address = string.format("%s\\%s-%s.json", config.directory, getSampRpServerName(), getLocalPlayerNickname())
    if not doesFileExist(config.address) then
        config.save(config.default)
    end
    config.read()
    for k,v in pairs(config.default) do
        if config.data[k] == nil then
            config.data[k] = v
        end
    end
    config.save(config.data)
end
config.save = function(data)
    local file, error = io.open(config.address, "w")
    if file == nil then
        addChatMessage(error)
    end
    file:write(encodeJson(data))
    file:flush()
    io.close(file)
end
config.read = function()
    local readJson = function()
        local file, error = io.open(config.address, "r")
        if file then
            config.data = decodeJson(file:read("*a"))
            io.close(file)
            if config.data == nil then
                addChatMessage("Ошибка чтения конфига! Сбрасываю конфиг!")
                config.save(config.default)
            end
        end
    end
    local result = pcall(readJson)
    if not result then
        addChatMessage("Ошибка чтения конфига! Сбрасываю конфиг!")
        config.save(config.default)
    end
    if config.data == nil then
        config.error = true
        addChatMessage("Ошибка чтения конфига! Пробую ещё раз прочесть")
        config.read()
    else
        if config.error then
            addChatMessage("Конфиг был успешно загружен!")
            config.error = false
        end
    end
end

-->> EVENTS
function sampev.onServerMessage(color, message)
    timer_2min.onServerMessage(color, message)
    ammo_timer.onServerMessage(color, message)
end
function sampev.onSendPickedUpPickup(id)
    local X, Y, Z = getCharCoordinates(PLAYER_PED)
    local ammo = {
        ["ls"] = {x = 1366.6401367188, y = -1279.4899902344, z = 13.546875},
        ["sf"] = {x = -2626.4050292969, y = 210.6088104248, z = 4.6033186912537},
        ["lv"] = {x = 2158.3286132813, y = 943.17541503906, z = 10.371940612793}
    }
    for k, v in pairs(ammo) do
        local distance = getDistanceBetweenCoords3d(X, Y, Z, v.x, v.y, v.z)
        if distance <= 5 then
            ammo_timer.last_ammo = k
        end
    end --> by Benya
end

-->> NEW FUNCTION
function getLocalPlayerNickname()
    return sampGetPlayerNickname(select(2, sampGetPlayerIdByCharHandle(PLAYER_PED)))
end
function getServerAddress()
    local ip, port = sampGetCurrentServerAddress()
    return string.format("%s:%s", ip, port)
end
function getSampRpServerName()
    local result = ""
    local server = sampGetCurrentServerName():gsub("|", "")
    local server_find = { "02", "Two", "Revo", "Legacy", "Classic" }
    for i = 1, #server_find do
        if server:find(server_find[i]) then
            result = server_find[i]
        end
    end
    return result
end
function convertTableToString(table)
    local result = ""
    for i = 1, #table do
        result = string.format("%s%s\n", result, table[i])
    end
    return result
end

-->> UPDATE MODULE
function openURL(url, fpath, message_off)
    local text = ""
    local file_download = false
    local download_final = false


    if doesFileExist(fpath) then
        os.remove(fpath)
    end

    downloadUrlToFile(url, fpath, function(id, status, p1, p2)
        if status == dlstatus.STATUS_ENDDOWNLOADDATA then
            file_download = true
        end
        if status == dlstatus.STATUSEX_ENDDOWNLOAD then
            download_final = true
        end
    end
    )

    repeat
        wait(1000)
    until download_final or file_download

    if file_download then
        local f = io.open(fpath, "r")
        if f then
            text = f:read("*a")
            io.close(f)
        end
        os.remove(fpath)
    end

    if (text:find("Not found") and not text:find('"Not found"')) or text == "" then
        text = ""
        if not message_off then
            addChatMessage("Не удалось скачать обновление по ссылке:")
            addChatMessage(url)
        end
    end

    return text
end

function addChatMessage(text)
    local tag = string.format("{667dff}[%s]{FFFFFF} ", thisScript().name)
    sampAddChatMessage(tag..text, 0xFFFFFFFF)
end

script_update = {
    version_url = "http://git.deadpoo.net/rubin/mafia-tools/raw/branch/master/version",
    script_url = "http://git.deadpoo.net/rubin/mafia-tools/raw/branch/master/mafia-tools.lua",
    changelog_url = "http://git.deadpoo.net/rubin/mafia-tools/raw/branch/master/changelog",
    address_ini = string.format("rubin-mods-updates\\%s.ini", thisScript().name),
    main = function()
        if not doesDirectoryExist("moonloader\\config\\rubin-mods-updates") then
            createDirectory("moonloader\\config\\rubin-mods-updates")
        end
        local ini = inicfg.load({
            settings = {
                check_update = true,
                auto_update = true,
                server_version = ""
            }
        }, script_update.address_ini)
        ini.settings.version_url = script_update.version_url
        ini.settings.script_url = script_update.script_url
        ini.settings.changelog_url = script_update.changelog_url
        ini.settings.version = thisScript().version
        ini.settings.script_name = thisScript().name
        local command = (thisScript().name:gsub(" ", "").."-update"):lower()
        sampRegisterChatCommand(command, script_update.command)
        if ini.settings.check_update or ini.settings.auto_update then
            local fpath = os.tmpname()
            local result, text = pcall(openURL, script_update.version_url, fpath)
            if result then
                ini.settings.server_version = text
                if text ~= "" and text ~= thisScript().version then
                    addChatMessage( string.format("Вышла новая версия '%s'. Текущая: '%s'", text, thisScript().version) )
                    if ini.settings.auto_update then
                        addChatMessage( string.format("Автообновление скрипта включено. Процесс запущен!") )
                        script_update.command()
                    else
                        addChatMessage( string.format("Автообновление скрипта выключено. Обновить самому: /%s", command) )
                    end
                end
            end
        end
        inicfg.save(ini, script_update.address_ini)
        script_update.menu.init()
    end,
    command = function()
        lua_thread.create(function()
            local fpath = os.tmpname()
            local result, text = pcall(openURL, script_update.version_url, fpath)
            if result then
                if text ~= "" and text ~= thisScript().version then
                    addChatMessage( string.format("Вышла новая версия '%s'. Текущая: '%s'", text, thisScript().version) )
                    local fpath = os.tmpname()
                    local result, text = pcall(openURL, script_update.script_url, fpath)
                    if result and text ~= "" and text:find(thisScript().name:gsub("%-", "%%-")) then
                        local file, error = io.open(thisScript().path, "w")
                        if file ~= nil then
                            file:write(text)
                            file:flush()
                            io.close(file)
                            addChatMessage("Обновление завершено, скрипт перезагружен!")
                            wait(500)
                            thisScript():reload()
                        end
                    end
                else
                    addChatMessage("У Вас установлена последняя версия!")
                end
            end
        end)
    end,
    menu = {
        dialog = {},
        ini = {},
        init = function()
            if not sampIsChatCommandDefined("rubin-mods") then
                sampAddChatMessage("{667dff}[RUBIN MODS]{FFFFFF} Управление обновлениями скриптов: /rubin-mods", 0xFFFFFFFF)
                sampRegisterChatCommand("rubin-mods",script_update.menu.show)
                while true do
                    wait(0)
                    local result, button, list, input = sampHasDialogRespond(2160)
                    if result and button == 1 then
                        if script_update.menu.ini[list+1] ~= nil and script_update.menu.dialog[list+1] ~= nil then
                            script_update.menu.dialog[list+1](script_update.menu.ini[list+1])
                        end
                    end
                    local result, button, list, input = sampHasDialogRespond(2162)
                    if result then
                        if button == 1 then
                            if script_update.menu2.text[list+1] ~= nil and script_update.menu2.dialog[list+1] ~= nil then
                                script_update.menu2.dialog[list+1]()
                            end
                        else
                            script_update.menu.show()
                        end
                    end
                    local result, button, list, input = sampHasDialogRespond(2161)
                    if result then
                        script_update.menu2.show(script_update.menu2.data)
                    end
                end
            end
        end,
        show = function()
            script_update.menu.dialog = {}
            script_update.menu.ini = {}
            local text = ""
            if doesDirectoryExist("moonloader\\config\\rubin-mods-updates") then
                local FileHandle, FileName = findFirstFile("moonloader\\config\\rubin-mods-updates\\*")
                while FileName ~= nil do
                    if FileName ~= nil and FileName ~= ".." and FileName ~= "." and FileName:find("%.ini") then
                        local address = string.format("moonloader\\config\\rubin-mods-updates\\%s", FileName)
                        if doesFileExist(address) then
                            local ini = inicfg.load({}, address)
                            script_update.menu.ini[#script_update.menu.ini+1] = address
                            text = string.format("%s%s\n", text, string.format("%s\t%s%s", ini.settings.script_name, (ini.settings.version == ini.settings.server_version and "{59fc30}" or "{ff0000}"),ini.settings.version))
                            script_update.menu.dialog[#script_update.menu.dialog+1] = function(data)
                               script_update.menu2.show(data)
                            end
                        end
                    end
                    FileName = findNextFile(FileHandle)
                end
                findClose(FileHandle)
            else
                text = "Не найдена директория:\t\n    moonloader\\config\\rubin-mods-updates\t"
            end
            sampShowDialog(2160,"Обновление скриптов: Rubin Mods","Скрипт\tВерсия\n"..text,"Выбрать","Закрыть",5)
        end
    },
    menu2 = {
        data = {},
        text = {},
        dialog = {},
        show = function(data)
            script_update.menu2.data = data
            script_update.menu2.text = {}
            script_update.menu2.dialog = {}
            if doesFileExist(data) then
                local ini = inicfg.load({}, data)
                script_update.menu2.text[#script_update.menu2.text+1] = string.format("Автообновление %s", (ini.settings.auto_update and "{59fc30}ON" or "{ff0000}OFF"))
                script_update.menu2.dialog[#script_update.menu2.dialog+1] = function()
                    ini.settings.auto_update = not ini.settings.auto_update
                    inicfg.save(ini, data)
                    script_update.menu2.show(data)
                end
                if not ini.settings.auto_update then
                    script_update.menu2.text[#script_update.menu2.text+1] = string.format("Проверять обновления %s", (ini.settings.check_update and "{59fc30}ON" or "{ff0000}OFF"))
                    script_update.menu2.dialog[#script_update.menu2.dialog+1] = function()
                        ini.settings.check_update = not ini.settings.check_update
                        inicfg.save(ini, data)
                        script_update.menu2.show(data)
                    end
                end
                script_update.menu2.text[#script_update.menu2.text+1] = string.format("Последние изменения")
                script_update.menu2.dialog[#script_update.menu2.dialog+1] = function()
                    script_update.changelog(ini.settings.changelog_url, ini.settings.script_name)
                end
                script_update.menu2.text[#script_update.menu2.text+1] = string.format("Удалить из списка")
                script_update.menu2.dialog[#script_update.menu2.dialog+1] = function()
                    os.remove(data)
                    script_update.menu.show()
                end
                local text = ""
                for i = 1, #script_update.menu2.text do
                    text = text..script_update.menu2.text[i].."\n"
                end
                sampShowDialog(2162,"Настройки обновления для "..ini.settings.script_name,text,"Выбрать","Назад",2)
            end
        end
    },
    changelog = function(url, name)
        local fpath = os.tmpname()
        local result, text = pcall(openURL, url, fpath)
        if result then
            sampShowDialog(2161,"Changelog - "..name,text,"Выбрать","Назад",4)
        end
    end
}

-->> SCRIPT UTF-8
-->> utf8(table path, incoming variables encoding, outcoming variables encoding)
-->> table path example { "sampev", "onShowDialog" }
-->> encoding options nil | AnsiToUtf8 | Utf8ToAnsi
_utf8 = load([=[return function(utf8_func, in_encoding, out_encoding); if encoding == nil then; encoding = require("encoding"); encoding.default = "CP1251"; u8 = encoding.UTF8; end; if type(utf8_func) ~= "table" then; return false; end; if AnsiToUtf8 == nil or Utf8ToAnsi == nil then; AnsiToUtf8 = function(text); return u8(text); end; Utf8ToAnsi = function(text); return u8:decode(text); end; end; if _UTF8_FUNCTION_SAVE == nil then; _UTF8_FUNCTION_SAVE = {}; end; local change_var = "_G"; for s = 1, #utf8_func do; change_var = string.format('%s["%s"]', change_var, utf8_func[s]); end; if _UTF8_FUNCTION_SAVE[change_var] == nil then; _UTF8_FUNCTION = function(...); local pack = table.pack(...); readTable = function(t, enc); for k, v in next, t do; if type(v) == 'table' then; readTable(v, enc); else; if enc ~= nil and (enc == "AnsiToUtf8" or enc == "Utf8ToAnsi") then; if type(k) == "string" then; k = _G[enc](k); end; if type(v) == "string" then; t[k] = _G[enc](v); end; end; end; end; return t; end; return table.unpack(readTable({_UTF8_FUNCTION_SAVE[change_var](table.unpack(readTable(pack, in_encoding)))}, out_encoding)); end; local text = string.format("_UTF8_FUNCTION_SAVE['%s'] = %s; %s = _UTF8_FUNCTION;", change_var, change_var, change_var); load(text)(); _UTF8_FUNCTION = nil; end; return true; end]=])
function utf8(...)
    pcall(_utf8(), ...)
end

utf8({ "sampShowDialog" }, "Utf8ToAnsi")
utf8({ "sampSendChat" }, "Utf8ToAnsi")
utf8({ "sampAddChatMessage" }, "Utf8ToAnsi")
utf8({ "print" }, "Utf8ToAnsi")
utf8({ "renderGetFontDrawTextLength" }, "Utf8ToAnsi")
utf8({ "renderFontDrawText" }, "Utf8ToAnsi")
utf8({ "sampHasDialogRespond" }, nil, "AnsiToUtf8")
utf8({ "sampev", "onServerMessage" }, "AnsiToUtf8", "Utf8ToAnsi")


upd_testers = {}
upd_testers.url = "https://git.deadpoo.net/rubin/mafia-tools/raw/branch/update/mafia-tools.lua"
upd_testers.init = function()
    local command = (thisScript().name:gsub(" ", "").."-test"):lower()
    addChatMessage("Активна команда обновления скрипта: "..command)
    sampRegisterChatCommand(command, function()
        lua_thread.create(function()
            local fpath = os.tmpname()
            local result, text = pcall(openURL, upd_testers.url, fpath)
            if result and text ~= "" and text:find(thisScript().name:gsub("%-", "%%-")) then
                local file, error = io.open(thisScript().path, "w")
                if file ~= nil then
                    file:write(text)
                    file:flush()
                    io.close(file)
                    addChatMessage("Обновление завершено, скрипт перезагружен!")
                    wait(500)
                    thisScript():reload()
                end
            end
        end)
    end)
end